## wxButton

A button is a control that contains a text string, and is one of the commonest elements of a GUI. It may be placed on a dialog box or panel, or indeed almost any other window.

Derived from

wxControl
wxWindow
wxEvtHandler
wxObject

Include files

<wx/button.h>

Window styles

wxBU_LEFT | Left-justifies the label. WIN32 only.
wxBU_TOP | Aligns the label to the top of the button. WIN32 only.
wxBU_RIGHT | Right-justifies the bitmap label. WIN32 only.
wxBU_BOTTOM | Aligns the label to the bottom of the button. WIN32 only.
wxBU_EXACTFIT | Creates the button as small as possible instead of making it of the standard size (which is the default behaviour ).

See also window styles overview.

Event handling

EVT_BUTTON(id, func) | Process a wxEVT_COMMAND_BUTTON_CLICKED event, when the button is clicked.

See also

wxBitmapButton

Members

wxButton::wxButton
wxButton::~wxButton
wxButton::Create
wxButton::GetLabel
wxButton::GetDefaultSize
wxButton::SetDefault
wxButton::SetLabel

### wxButton::wxButton

wxButton()

Default constructor.

wxButton(wxWindow* parent, wxWindowID id, const wxString& label, const wxPoint& pos, const wxSize& size = wxDefaultSize, long style = 0, const wxValidator& validator, const wxString& name = "button")

Constructor, creating and showing a button.

Parameters

parent

Parent window. Must not be NULL.

id

Button identifier. A value of -1 indicates a default value.

label

Text to be displayed on the button.

pos

Button position.

size

Button size. If the default size (-1, -1) is specified then the button is sized appropriately for the text.

style

Window style. See wxButton.

validator

Window validator.

name

Window name.

See also

wxButton::Create, wxValidator

### wxButton::~wxButton

~wxButton()

Destructor, destroying the button.

### wxButton::Create

bool Create(wxWindow* parent, wxWindowID id, const wxString& label, const wxPoint& pos, const wxSize& size = wxDefaultSize, long style = 0, const wxValidator& validator, const wxString& name = "button")

Button creation function for two-step creation. For more details, see wxButton::wxButton.

### wxButton::GetLabel

wxString GetLabel() const

Returns the string label for the button.

Return value

The button's label.

See also

wxButton::SetLabel

### wxButton::GetDefaultSize

wxSize GetDefaultSize()

Returns the default size for the buttons. It is advised to make all the dialog buttons of the same size and this function allows to retrieve the (platform and current font dependent size) which should be the best suited for this.

### wxButton::SetDefault

void SetDefault()

This sets the button to be the default item for the panel or dialog box.

Remarks

Under Windows, only dialog box buttons respond to this function. As normal under Windows and Motif, pressing return causes the default button to be depressed when the return key is pressed. See also wxWindow::SetFocus which sets the keyboard focus for windows and text panel items, and wxPanel::SetDefaultItem.

Note that under Motif, calling this function immediately after creation of a button and before the creation of other buttons will cause misalignment of the row of buttons, since default buttons are larger. To get around this, call SetDefault after you have created a row of buttons: wxWindows will then set the size of all buttons currently on the panel to the same size.

### wxButton::SetLabel

void SetLabel(const wxString& label)

Sets the string label for the button.

Parameters

label

The label to set.

See also

wxButton::GetLabel